Bug 1462983 - Review Request: python-phonenumbers - A Python port of Google's libphonenumber
Review Request: python-phonenumbers - A Python port of Google's libphonenumber
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Filip Szymański
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2017-06-19 15:46 EDT by Jeremy Cline
Modified: 2017-07-07 18:57 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-07-07 18:57:31 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
fszymanski.pl: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Jeremy Cline 2017-06-19 15:46:21 EDT
SRPM URL: https://jcline.fedorapeople.org/python-phonenumbers-8.5.1-1.fc27.src.rpm
Spec URL: https://jcline.fedorapeople.org/python-phonenumbers.spec
Description:
A Python port of libphonenumber, Google's common Java, C++, and
JavaScript library for parsing, formatting, and validating international phone
numbers.            


Koji build: https://koji.fedoraproject.org/koji/taskinfo?taskID=20067935
FAS: jcline
Comment 1 Filip Szymański 2017-06-21 03:46:24 EDT
1) Remove `v` from `%{name}-v%{version}.tar.gz` in Source0.
2) Remove shebang from util.py:

Example:

%prep
%autosetup

sed -i.orig '1{\@^#!/usr/bin/env python@d}' python/phonenumbers/util.py
touch -r python/phonenumbers/util.py.orig python/phonenumbers/util.py
rm -f python/phonenumbers/util.py.orig
Comment 2 Yatin Karel 2017-06-21 05:45:49 EDT
This is un-official review of the package.

+ mock build is successful for fedora 25, fedora 26, tried package installation on
fedora 25, it was successful and functional.
+ Source Checksum same
+ License "ASL 2.0" is in Socure repo and is included in subpackages

- rpmlint contains Errors:-
Rpmlint
-------
Checking: python2-phonenumbers-8.5.1-1.fc25.noarch.rpm
          python3-phonenumbers-8.5.1-1.fc25.noarch.rpm
          python-phonenumbers-8.5.1-1.fc25.src.rpm
python2-phonenumbers.noarch: W: spelling-error Summary(en_US) libphonenumber -> cumbersomeness
python2-phonenumbers.noarch: W: spelling-error %description -l en_US libphonenumber -> cumbersomeness
python2-phonenumbers.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/phonenumbers/util.py /usr/bin/env python
python2-phonenumbers.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/phonenumbers/util.py 644 /usr/bin/env python
python3-phonenumbers.noarch: W: spelling-error Summary(en_US) libphonenumber -> cumbersomeness
python3-phonenumbers.noarch: W: spelling-error %description -l en_US libphonenumber -> cumbersomeness
python3-phonenumbers.noarch: E: wrong-script-interpreter /usr/lib/python3.5/site-packages/phonenumbers/util.py /usr/bin/env python
python3-phonenumbers.noarch: E: non-executable-script /usr/lib/python3.5/site-packages/phonenumbers/util.py 644 /usr/bin/env python
python-phonenumbers.src: W: spelling-error Summary(en_US) libphonenumber -> cumbersomeness
python-phonenumbers.src: W: spelling-error %description -l en_US libphonenumber -> cumbersomeness
3 packages and 0 specfiles checked; 4 errors, 6 warnings.

Rest looks Ok, few suggestions below:-

1) - %files contains *, should be good if * is replaced with module_name
2) - use python2-%{pypi_name} instead of python[23]-phonenumbers for consistency
3) use {} arond variables like __python --> %{__python} for consistency
Comment 3 Filip Szymański 2017-06-21 05:59:48 EDT
(In reply to Yatin Karel from comment #2)

> 1) - %files contains *, should be good if * is replaced with module_name
`*` captures both the module directory and the egg-info directory, see:
https://fedoraproject.org/wiki/Packaging:Python_Eggs#Providing_Egg_Metadata_Using_Setuptools

> 2) - use python2-%{pypi_name} instead of python[23]-phonenumbers for
> consistency
Yes

> 3) use {} arond variables like __python --> %{__python} for consistency
Yes
Comment 4 Jeremy Cline 2017-06-21 10:08:52 EDT
Thanks for the reviews!

> Remove `v` from `%{name}-v%{version}.tar.gz` in Source0.

Fancy, I assumed GitHub would get upset by this because the tag has a v in it, but it does the right thing!

> Remove shebang from util.py:

Done. An easier sed for this is ``sed -ie '1d' python/%{pypi_name}/util.py`` - I learned this from a different specfile yesterday :)

> %files contains *, should be good if * is replaced with module_name

I compromised here and included the module explicitly and specified the egg-info separately.

> use python2-%{pypi_name} instead of python[23]-phonenumbers for consistency

Good catch, fixed.

> use {} arond variables like __python --> %{__python} for consistency

Also fixed.

Koji build: https://koji.fedoraproject.org/koji/taskinfo?taskID=20078244

SRPM URL: https://jcline.fedorapeople.org/python-phonenumbers-8.5.1-2.fc27.src.rpm
Spec URL: https://jcline.fedorapeople.org/python-phonenumbers.spec
Comment 5 Filip Szymański 2017-06-22 04:39:30 EDT
(In reply to Jeremy Cline from comment #4)

> Done. An easier sed for this is ``sed -ie '1d' python/%{pypi_name}/util.py``
> - I learned this from a different specfile yesterday :)

Yes but this way you don't preserve the file timestamp.

See:
https://fedoraproject.org/wiki/Packaging:Guidelines#Timestamps
https://fedoraproject.org/wiki/Packaging_tricks#Remove_shebang_from_files
https://fedoraproject.org/wiki/Packaging_tricks#Remove_shebang_from_Python_libraries
Comment 6 Jeremy Cline 2017-06-22 10:13:43 EDT
(In reply to Filip Szymański from comment #5)
> Yes but this way you don't preserve the file timestamp.
> 
> See:
> https://fedoraproject.org/wiki/Packaging:Guidelines#Timestamps
> https://fedoraproject.org/wiki/Packaging_tricks#Remove_shebang_from_files
> https://fedoraproject.org/wiki/
> Packaging_tricks#Remove_shebang_from_Python_libraries

Fair point. Do you consider this a blocker for approval?
Comment 7 Filip Szymański 2017-06-22 10:39:07 EDT
(In reply to Jeremy Cline from comment #6)
> Fair point. Do you consider this a blocker for approval?

No. When I find some free time later today I will do a review with the `fedora-review` tool and I approve the package.
Comment 8 Filip Szymański 2017-06-22 16:02:13 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "Apache", "Unknown or generated", "*No
     copyright* Apache (v2.0)". 788 files have unknown license. Detailed
     output of licensecheck in /tmp/1462983-python-
     phonenumbers/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/python3.6/site-
     packages, /usr/lib/python3.6
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 40960 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python2-phonenumbers , python3-phonenumbers
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[!]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python2-phonenumbers-8.5.1-2.fc27.noarch.rpm
          python3-phonenumbers-8.5.1-2.fc27.noarch.rpm
          python-phonenumbers-8.5.1-2.fc27.src.rpm
python2-phonenumbers.noarch: W: spelling-error Summary(en_US) libphonenumber -> cumbersomeness
python2-phonenumbers.noarch: W: spelling-error %description -l en_US libphonenumber -> cumbersomeness
python3-phonenumbers.noarch: W: spelling-error Summary(en_US) libphonenumber -> cumbersomeness
python3-phonenumbers.noarch: W: spelling-error %description -l en_US libphonenumber -> cumbersomeness
python-phonenumbers.src: W: spelling-error Summary(en_US) libphonenumber -> cumbersomeness
python-phonenumbers.src: W: spelling-error %description -l en_US libphonenumber -> cumbersomeness
3 packages and 0 specfiles checked; 0 errors, 6 warnings.




Rpmlint (installed packages)
----------------------------
python3-phonenumbers.noarch: W: spelling-error Summary(en_US) libphonenumber -> cumbersomeness
python3-phonenumbers.noarch: W: spelling-error %description -l en_US libphonenumber -> cumbersomeness
python2-phonenumbers.noarch: W: spelling-error Summary(en_US) libphonenumber -> cumbersomeness
python2-phonenumbers.noarch: W: spelling-error %description -l en_US libphonenumber -> cumbersomeness
2 packages and 0 specfiles checked; 0 errors, 4 warnings.



Requires
--------
python3-phonenumbers (rpmlib, GLIBC filtered):
    python(abi)

python2-phonenumbers (rpmlib, GLIBC filtered):
    python(abi)



Provides
--------
python3-phonenumbers:
    python3-phonenumbers
    python3.6dist(phonenumbers)
    python3dist(phonenumbers)

python2-phonenumbers:
    python-phonenumbers
    python2-phonenumbers
    python2.7dist(phonenumbers)
    python2dist(phonenumbers)



Source checksums
----------------
https://github.com/daviddrysdale/python-phonenumbers/archive/v8.5.1/python-phonenumbers-8.5.1.tar.gz :
  CHECKSUM(SHA256) this package     : 8b2fa2367108d42ef4d2147ae21f0dcae9112c683480708c99c6c8aeee1a2f9b
  CHECKSUM(SHA256) upstream package : 8b2fa2367108d42ef4d2147ae21f0dcae9112c683480708c99c6c8aeee1a2f9b


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1462983
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6



Conclusions:

One fail. As I said before packages should try to preserve timestamps of original installed files. It's a SHOULD and not a MUST item, so I leave it to you if you want to fix it.

Note: A new version has just been released (8.5.2).

Approved!
Comment 9 Jeremy Cline 2017-06-22 16:26:03 EDT
Thanks for the review! I'll definitely fix the timestamp issue when I import it.
Comment 10 Yatin Karel 2017-06-22 23:25:56 EDT
Thanks Jeremy, for addressing the comments :)
Comment 11 Gwyn Ciesla 2017-06-23 08:14:14 EDT
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/python-phonenumbers
Comment 12 Fedora Update System 2017-06-23 09:26:39 EDT
python-phonenumbers-8.5.2-1.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-67f5adee78
Comment 13 Fedora Update System 2017-06-23 21:22:58 EDT
python-phonenumbers-8.5.2-1.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-67f5adee78
Comment 14 Fedora Update System 2017-07-07 18:57:31 EDT
python-phonenumbers-8.5.2-1.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.